package com.umfintech.umfpaysdk;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */

import org.json.JSONObject;

import java.util.Map;

public final class EventCall {
    public final Object arguments;

    public EventCall(Object arguments) {
        this.arguments = arguments;
    }

    public Object argument(String key) {
        if (this.arguments == null) {
            return null;
        } else if (this.arguments instanceof Map) {
            return ((Map)this.arguments).get(key);
        } else if (this.arguments instanceof JSONObject) {
            return ((JSONObject)this.arguments).opt(key);
        } else {
            throw new ClassCastException();
        }
    }

    public boolean hasArgument(String key) {
        if (this.arguments == null) {
            return false;
        } else if (this.arguments instanceof Map) {
            return ((Map)this.arguments).containsKey(key);
        } else if (this.arguments instanceof JSONObject) {
            return ((JSONObject)this.arguments).has(key);
        } else {
            throw new ClassCastException();
        }
    }
}
