package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.BankCardPayResponse;
import com.umpay.payplugin.callback.UMBankCardPayCallback;
import com.umpay.payplugin.code.UMCardCode;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.EventChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class BankCardPayCallBack extends BaseCallBack implements UMBankCardPayCallback {

    public BankCardPayCallBack(Context context, EventChannel.EventSink eventSink) {
        super(context, eventSink);
    }

    @Override
    public void onPaySuccess(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardPay",  "onPaySuccess: " + bankCardPayResponse.toString());
        eventSink.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, bankCardPayResponse)));
    }

    @Override
    public void onPayFail(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardPay",  "onPayFail: " + bankCardPayResponse.toString());
        eventSink.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, bankCardPayResponse)));
    }

    @Override
    public void onPayUnknown(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardPay",  "onPayUnknown: " + bankCardPayResponse.toString());
        eventSink.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_UNKNOWN, bankCardPayResponse)));
    }

    @Override
    public void onProgressUpdate(BankCardPayResponse bankCardPayResponse) {
        if (UMCardCode.START_DOWNLOAD_KEY == bankCardPayResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 开始下载密钥！");
            eventSink.success(getProgressUpdate(bankCardPayResponse.code, "开始下载密钥"));
        } else if (UMCardCode.START_READ_CARD == bankCardPayResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 密钥下载成功，开始刷卡！");
            eventSink.success(getProgressUpdate(bankCardPayResponse.code, "密钥下载成功，开始刷卡"));
        } else if (UMCardCode.PASSWORD_KEYBOARD_OPEN == bankCardPayResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 刷卡成功，请输入密码！");
            eventSink.success(getProgressUpdate(bankCardPayResponse.code, "刷卡成功，请输入密码"));
        } else if (UMCardCode.SEND_PAY_REQUEST == bankCardPayResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 密码输入成功，发起支付！");
            eventSink.success(getProgressUpdate(bankCardPayResponse.code, "密码输入成功，发起支付"));
        }
    }
}
