package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.RefundResponse;
import com.umpay.payplugin.callback.UMRefundCallback;
import com.umpay.payplugin.code.UMRefundCode;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.EventChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class BankRefundCallback extends BaseCallBack implements UMRefundCallback {
    public BankRefundCallback(Context context, EventChannel.EventSink eventSink) {
        super(context, eventSink);
    }

    @Override
    public void onRefundSuccess(RefundResponse refundResponse) {
        UMPayLog.i("bankRefund",  "onRefundSuccess: " + refundResponse.toString());
        eventSink.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, refundResponse)));
    }

    @Override
    public void onRefundFail(RefundResponse refundResponse) {
        UMPayLog.i("bankRefund",  "onRefundFail: " + refundResponse.toString());
        eventSink.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, refundResponse)));
    }

    @Override
    public void onRefundUnknown(RefundResponse refundResponse) {
        UMPayLog.i("bankRefund",  "onRefundUnknown: " + refundResponse.toString());
        eventSink.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_UNKNOWN, refundResponse)));
    }

    @Override
    public void onProgressUpdate(RefundResponse refundResponse) {
        if (UMRefundCode.START_DOWNLOAD_KEY == refundResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 开始下载密钥！");
            eventSink.success(getProgressUpdate(refundResponse.code, "开始下载密钥"));
        } else if (UMRefundCode.START_READ_CARD == refundResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 密钥下载成功，开始刷卡！");
            eventSink.success(getProgressUpdate(refundResponse.code, "密钥下载成功，开始刷卡"));
        } else if (UMRefundCode.PASSWORD_KEYBOARD_OPEN == refundResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 刷卡成功，请输入密码！");
            eventSink.success(getProgressUpdate(refundResponse.code, "刷卡成功，请输入密码"));
        } else if (UMRefundCode.SEND_REFUND_REQUEST == refundResponse.code) {
            UMPayLog.i("cardPay",  "onProgressUpdate: 密码输入成功，发起支付！");
            eventSink.success(getProgressUpdate(refundResponse.code, "密码输入成功，发起支付"));
        }
    }
}
