package com.umfintech.umfpaysdk.callback;

import android.content.Context;
import android.util.Log;

import com.umfintech.umfpaysdk.SdkManager;
import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.UMPay;
import com.umpay.payplugin.callback.UMBindCallBack;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class BaseCallBack {
    MethodChannel.Result result;
    EventChannel.EventSink eventSink;
    Context context;
    BaseCallBack(Context context, MethodChannel.Result result) {
        this.context = context;
        this.result = result;
    }

    BaseCallBack(Context context, EventChannel.EventSink eventSink) {
        this.context = context;
        this.eventSink = eventSink;
    }

    public void onReBind(int code, String msg) {
        UMPayLog.i("cardPay",  "onReBind: code: " + code + "msg: " + msg);
        UMPay.getInstance().bind(context, new UMBindCallBack() {
            @Override
            public void bindException(Exception ee) {
                Log.e("123", ee.getMessage());
            }

            @Override
            public void bindSuccess() {
                Log.e("123", "绑定成功");
            }

            @Override
            public void bindDisconnected() {
                Log.e("123", "断开绑定");
            }
        });

        Map<String, String> resultData = new HashMap<>();
        resultData.put("code", String.valueOf(code));
        resultData.put("message", msg);
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, resultData)));
    }

    static String getProgressUpdate(int code, String message) {
        Map<String, Object> result = new HashMap<>();
        result.put("code", code);
        result.put("message", message);
        return FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_PROCESS, result));
    }

    static Map<String, Object> getResultMessage(String message) {
        Map<String, Object> result = new HashMap<>();
        result.put("message", message);
        return result;
    }
}
