package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.BankCardPayResponse;
import com.umpay.payplugin.callback.UMCardPayQueryCallback;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class CardPayQueryCallBack extends BaseCallBack implements UMCardPayQueryCallback {

    public CardPayQueryCallBack(Context context, MethodChannel.Result result) {
        super(context, result);
    }

    @Override
    public void onPaySuccess(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardQuery",  "onPaySuccess: " + bankCardPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, bankCardPayResponse)));
    }

    @Override
    public void onPayFail(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardQuery",  "onPayFail: " + bankCardPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, bankCardPayResponse)));
    }

    @Override
    public void onPaying(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardQuery",  "onPaying: " + bankCardPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_PROCESS, bankCardPayResponse)));
    }

    @Override
    public void onQueryError(BankCardPayResponse bankCardPayResponse) {
        UMPayLog.i("cardQuery",  "onQueryError: " + bankCardPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_ERROR, bankCardPayResponse)));
    }
}
