package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.OrderListResponse;
import com.umpay.payplugin.callback.ListCallBack;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class QueryListCallBack extends BaseCallBack implements ListCallBack {
    public QueryListCallBack(Context context, MethodChannel.Result result) {
        super(context, result);
    }

    @Override
    public void onSuccess(OrderListResponse orderListResponse) {
        UMPayLog.i("queryList",  "onSuccess: " + orderListResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, orderListResponse)));
    }

    @Override
    public void onFail(OrderListResponse orderListResponse) {
        UMPayLog.i("queryList",  "onFail: " + orderListResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, orderListResponse)));
    }

    @Override
    public void onError(OrderListResponse orderListResponse) {
        UMPayLog.i("queryList",  "onError: " + orderListResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_ERROR, orderListResponse)));
    }
}
