package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.RefundResponse;
import com.umpay.payplugin.callback.UMRefundStateQueryCallback;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class RefundStateQueryCallback extends BaseCallBack implements UMRefundStateQueryCallback {
    public RefundStateQueryCallback(Context context, MethodChannel.Result result) {
        super(context, result);
    }

    @Override
    public void onRefundSuccess(RefundResponse refundResponse) {
        UMPayLog.i("refundQuery",  "onPaySuccess: " + refundResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, refundResponse)));
    }

    @Override
    public void onRefundFail(RefundResponse refundResponse) {
        UMPayLog.i("refundQuery",  "onRefundFail: " + refundResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, refundResponse)));
    }

    @Override
    public void onQueryError(RefundResponse refundResponse) {
        UMPayLog.i("refundQuery",  "onQueryError: " + refundResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_ERROR, refundResponse)));
    }
}
