package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkManager;
import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.UMPay;
import com.umpay.payplugin.bean.ScanPayResponse;
import com.umpay.payplugin.callback.UMScanPayCallback;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class ScanPayCallBack extends BaseCallBack implements UMScanPayCallback {

    public ScanPayCallBack(Context context, MethodChannel.Result result) {
        super(context, result);
    }

    @Override
    public void onPaySuccess(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanPay",  "onPaySuccess: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, scanPayResponse)));
    }

    @Override
    public void onPayFail(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanPay",  "onPayFail: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, scanPayResponse)));
    }

    @Override
    public void onPayUnknown(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanPay",  "onPayUnknown: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_UNKNOWN, scanPayResponse)));
    }
}
