package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.ScanPayResponse;
import com.umpay.payplugin.callback.UMScanQueryCallback;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class ScanQueryCallBack extends BaseCallBack implements UMScanQueryCallback {

    public ScanQueryCallBack(Context context, MethodChannel.Result result) {
        super(context, result);
    }

    @Override
    public void onPaySuccess(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanQuery",  "onPaySuccess: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, scanPayResponse)));
    }

    @Override
    public void onPayFail(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanQuery",  "onPayFail: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, scanPayResponse)));
    }

    @Override
    public void onPaying(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanQuery",  "onPaying: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_PROCESS, scanPayResponse)));
    }

    @Override
    public void onQueryError(ScanPayResponse scanPayResponse) {
        UMPayLog.i("scanQuery",  "onQueryError: " + scanPayResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_ERROR, scanPayResponse)));
    }
}
