package com.umfintech.umfpaysdk.callback;

import android.content.Context;

import com.umfintech.umfpaysdk.SdkResult;
import com.umpay.payplugin.bean.RefundResponse;
import com.umpay.payplugin.callback.UMScanRefundCallback;
import com.umpay.payplugin.util.FastJsonUtils;
import com.umpay.payplugin.util.UMPayLog;

import io.flutter.plugin.common.MethodChannel;

/**
 * dec:
 *
 * @author hanpeidong on 2019/8/2.
 */
public class ScanRefundCallback extends BaseCallBack implements UMScanRefundCallback {
    public ScanRefundCallback(Context context, MethodChannel.Result result) {
        super(context, result);
    }

    @Override
    public void onRefundSuccess(RefundResponse refundResponse) {
        UMPayLog.i("scanRefund",  "onRefundSuccess: " + refundResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_SUCCESS, refundResponse)));
    }

    @Override
    public void onRefundFail(RefundResponse refundResponse) {
        UMPayLog.i("scanRefund",  "onRefundFail: " + refundResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_FAILED, refundResponse)));
    }

    @Override
    public void onRefundUnknown(RefundResponse refundResponse) {
        UMPayLog.i("scanRefund",  "onRefundUnknown: " + refundResponse.toString());
        result.success(FastJsonUtils.toJson(new SdkResult<>(SdkResult.TYPE_UNKNOWN, refundResponse)));
    }
}
