import 'package:flutter/material.dart';
import 'package:umfpaysdk/print_info.dart';
import 'package:umfpaysdk/umfpaysdk.dart';

import 'util.dart';

/// desc:
/// author: hanpeidong
/// time: 2019/8/2
class DeviceCard extends StatefulWidget {
  @override
  _DeviceCardState createState() => _DeviceCardState();
}

class _DeviceCardState extends State<DeviceCard> {
  @override
  Widget build(BuildContext context) {
    return Card(
      color: Colors.blue,
      elevation: 5,
      shape: new RoundedRectangleBorder(
          borderRadius: new BorderRadius.circular(5)),
      child: Padding(
        padding: EdgeInsets.all(8),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: <Widget>[
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                print("start init");
                Umfpaysdk.init().then((result) {
                  print("init result: " + result);
                  showAlertDialog(context, result);
                });
              },
              child: Text(
                "初始化绑定",
                style: TextStyle(color: Colors.white),
              ),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                print("start dispose");
                Umfpaysdk.dispose().then((result) {
                  print("dispose result: " + result);
                  showAlertDialog(context, result);
                });
              },
              child: Text(
                "解绑",
                style: TextStyle(color: Colors.white),
              ),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                print("start getDeviceSN");
                Umfpaysdk.getDeviceSN().then((result) {
                  print("getDeviceSN result: $result");
                  showAlertDialog(context, result.toString());
                });
              },
              child: Text(
                "获取SN",
                style: TextStyle(color: Colors.white),
              ),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                print("start print");
                List<PrintInfo> contents = [
                    PrintInfo.fromContent("测试打印结果", 1, 2),
                    PrintInfo.fromFreeLine("2"),
                    PrintInfo.fromLine(),
                    PrintInfo.fromOneCode("WWW.baidu.com", 1, 2, -1),
                    PrintInfo.fromQRCode("123454566", 1, 2),
                  ];
                print("start print content: " + contents.toString());
                Umfpaysdk.printer(contents, onEvent: _onEvent, onError: _onError);
              },
              child: Text(
                "打印",
                style: TextStyle(color: Colors.white),
              ),
            ),
          ],
        ),
      ),
    );
  }

  // 回调事件
  void _onEvent(Object event) {
    print("刷卡付 result: " + event);
    showAlertDialog(context, event);
  }

  // 错误返回
  void _onError(Object error) {
    print("刷卡付 result: Error");
    showAlertDialog(context, "Error");
  }
}
