import 'package:flutter/material.dart';
import 'package:umfpaysdk/pay_sdk_request.dart';
import 'package:umfpaysdk/umfpaysdk.dart';

import 'util.dart';

/// desc:
/// author: hanpeidong
/// time: 2019/8/2
class ScanPayCard extends StatefulWidget {
  @override
  _ScanPayCardState createState() => _ScanPayCardState();
}

class _ScanPayCardState extends State<ScanPayCard> {
  TextEditingController qrController = TextEditingController();
  TextEditingController orderIdController = TextEditingController(text: getOrderId());

  @override
  Widget build(BuildContext context) {
    return Card(
      color: Colors.blue,
      elevation: 5,
      shape: new RoundedRectangleBorder(
          borderRadius: new BorderRadius.circular(4)),
      child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: <Widget>[
            TextField(
              controller: qrController,
              decoration: InputDecoration(
                prefixText: "二维码值：",
              ),
            ),
            TextField(
              controller: orderIdController,
              decoration: InputDecoration(
                prefixText: "订单号：",
              ),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                PaySdkRequest request = PaySdkRequest(
                    amount: 1,
                    mediaNo: qrController.text,
                    goodsDescribe: "商品描述",
                    goodsInfo: "商品信息",
                    orderId: orderIdController.text);
                Umfpaysdk.scanPay(request).then((result) {
                  print("scanPay result: " + result.toString());
                  showAlertDialog(context, result.toString());
                });
              },
              child: Text("扫码付", style: TextStyle(color: Colors.white),),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                PaySdkRequest request = PaySdkRequest(
                    payType: "WX",
                    orderDate: "",
                    orderId: orderIdController.text);
                Umfpaysdk.scanQuery(request).then((result) {
                  print("scanPay result: $result");
                  showAlertDialog(context, result.toString());
                });
              },
              child: Text("扫码付订单状态查询", style: TextStyle(color: Colors.white),),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                PaySdkRequest request = PaySdkRequest(
                    amount: 3000,
                    payType: "WX",
                    orderDate: "20190820",
                    orderId: "11313131313212313");
//                    orderId: orderIdController.text);
                Umfpaysdk.scanRevoke(request).then((result) {
                  print("scanRevoke result: $result");
                  showAlertDialog(context, result.toString());
                });
              },
              child: Text("扫码付撤销", style: TextStyle(color: Colors.white),),
            ),
            FlatButton(
              color: Colors.deepOrange,
              onPressed: () {
                PaySdkRequest request = PaySdkRequest(
                    amount: 1,
                    payType: "WX",
                    orderDate: "20190802",
                    orderId: orderIdController.text,
                    refundPartnerOrderId: "refundPartner${orderIdController.text}"
                );
                Umfpaysdk.scanRefund(request).then((result) {
                  print("scanRefund result: $result");
                  showAlertDialog(context, result.toString());
                });
              },
              child: Text("扫码付退款", style: TextStyle(color: Colors.white),),
            ),
          ],
        ),
      ),
    );
  }
}
