import 'package:flutter/material.dart';

/// desc:
/// author: hanpeidong
/// time: 2019/8/2

Future<Null> showAlertDialog(BuildContext context, String content,
    {String title = "提示",
    AlertType alertType = AlertType.CONFIRM,
    VoidCallback onConfirm}) {
  return showCustomDialog(
      context: context,
      builder: (_) => new AlertDialog(
              title: new Text(title),
              content: new Text(content),
              actions: <Widget>[
                new FlatButton(
                  child: new Text("取消"),
                  onPressed: () {
                    Navigator.of(context).pop();
                  },
                ),
                new FlatButton(
                  child: new Text("确定"),
                  onPressed: () {
                    Navigator.of(context).pop();
                    onConfirm?.call();
                  },
                )
              ]));
}

///弹出 dialog
Future<T> showCustomDialog<T>({
  @required BuildContext context,
  bool barrierDismissible = true,
  WidgetBuilder builder,
}) {
  return showDialog<T>(
      context: context,
      barrierDismissible: barrierDismissible,
      builder: (context) {
        return MediaQuery(

            ///不受系统字体缩放影响
            data: MediaQueryData.fromWindow(WidgetsBinding.instance.window)
                .copyWith(textScaleFactor: 1),
            child: new SafeArea(child: builder(context)));
      });
}

String getOrderId() {
  return DateTime.now().millisecondsSinceEpoch.toString();
}

enum AlertType { CONFIRM, CANCEL, CANCEL_CONFIRM }
