import 'package:umfpaysdk/result_code.dart';

///
class PaySdkResult {
  bool isCash;
  ScanPayCode scanPayCode;
  CardPayCode cardPayCode;
  String amount;
  int code;
  String coupAmount;
  String message;
  String orderDate;
  String orderId;
  String payAmount;
  String payDay;
  String paySeq;
  String cardPayType;
  String payType;
  String platTime;
  String tradeNo;

  PaySdkResult.fromCash(): isCash = true, payType = "XJ";

  PaySdkResult.fromJson(Map<String, dynamic> jsonData) {
    amount = jsonData['amount'];
    code = jsonData['code'];
    scanPayCode = ScanPayCode(code.toString());
    cardPayCode = CardPayCode(code.toString());
    isCash = false;
    coupAmount = jsonData['coupAmount'];
    message = jsonData['message'];
    orderDate = jsonData['orderDate'];
    orderId = jsonData['orderId'];
    payAmount = jsonData['payAmount'];
    payDay = jsonData['payDay'];
    paySeq = jsonData['paySeq'];
    payType = jsonData['payType'];
    platTime = jsonData['platTime'];
    tradeNo = jsonData['tradeNo'];
    cardPayType = jsonData['cardPayType'];
  }

  @override
  String toString() {
    StringBuffer sb = new StringBuffer('{');
    sb.write("\"amount\":$amount");
    sb.write("\"code\":$code");
    sb.write("\"coupAmount\":$coupAmount");
    sb.write("\"message\":$message");
    sb.write("\"orderDate\":$orderDate");
    sb.write("\"orderId\":$orderId");
    sb.write("\"payAmount\":$payAmount");
    sb.write("\"payDay\":$payDay");
    sb.write("\"paySeq\":$paySeq");
    sb.write("\"payType\":$payType");
    sb.write("\"platTime\":$platTime");
    sb.write("\"tradeNo\":$tradeNo");
    sb.write("\"cardPayType\":$cardPayType");
    sb.write('}');
    return sb.toString();
  }
}