///
class ScanPayCode {
  static const String PAY_SUCCESS = "60010200"; //支付成功//支付成功"; //

  static const String MEDIANO_IS_NULL =
      "60010001"; //二维码为空//支付时传入的二维码信息为空//支付码信息有误，请稍后重试
  static const String MEDIANO_IS_ORTHER =
      "60010002"; //二维码不是微信、支付宝、银联二维码的格式//通过传入的二维码信息来判断是否符合规范，如果不符合会提示这个返回信息//支付码信息有误，请稍后重试
  static const String JSON_IS_NULL = "60010003"; //支付信息为空////
  static const String JSON_PARSE_ERROE =
      "60010004"; //第三方请求支付信息解析错误//"调用SDK支付方法传入的json结构不对，如果使用SDK提供的方法调用不会出现这种情况 "//支付信息有误，请稍后重试
  static const String NET_ERROR =
      "60010005"; //服务器异常，请稍后在试//"发生在扫码付支付，请求服务器，没有响应的情况下UnknownHostException"//支付处理异常，请稍后再试
  static const String PAY_FAIL =
      "60010007"; //交易失败//"原因1：扫码支付的过程中种种原因(密码错误，余额不足等)导致交易失败，原因2 由于网络原因不知道支付结果最终调用的撤销成功之后也是交易失败"//交易失败，请重新发起交易
  static const String ORDER_FORMAT_ERROR =
      "60010008"; //订单号格式不正确//订单为空或长度大于32//订单有误，请重试
  static const String BIND_ERROE =
      "60010009"; //绑定失败，请检查是否添加了权限//"绑定支付插件的时候绑定失败提示原因：清单文件没有添加权限或POS机中没有安装支付插件"//权限不足，请校验后再试
  static const String SCAN_PAY_CALL_FAIL =
      "60010011"; //调用扫码付方法失败//调用aidl方法失败//支付有误，请重试
  static const String NO_NETWORK =
      "60010012"; //没有网络，请检查网络设置//没有网络//无网络，请连接网络后再试
  static const String NETWORK_ERROR =
      "60010014"; //网络异常，请重试！//网络异常，请重试！//网络异常，请重试！
  static const String PAY_RESULT_JSON_PARSE_FAIL =
      "60010013"; //支付返回的json数据解析对象时报错//"支付插件支付完成之后返回给SDK的json去解析成对象的时候报错，这种情况基本上不会出现"//请核实结果后重新支付
  static const String AMOUNT_IS_NULL = "60010015"; //金额格式不正确//金额格式不正确

  static const String REVOKE_PARSE_ERROE =
      "60010102"; //"撤销解析数据出错，支付未知处理，应该调用扫码付查询接口"//由于解析数据错误造成未知结果，应该调用查询接口查询支付状态//
  static const String REVOKE_TIMEOUT =
      "60010103"; //撤销超时，支付未知处理，应该调用扫码付查询接口//由于网络原因没有收到后台的响应，应该调用查询接口查询支付状态//
  static const String QUERY_UNKNOWN =
      "60010104"; //查询支付状态超时，支付未知处理，应该调用扫码付查询接口//由于网络原因没有收到后台的响应，应该调用查询接口查询支付状态//

  ScanPayCode(this.code);

  final String code;

  bool get isSuccess => code == PAY_SUCCESS;

  bool get isFailed => code == MEDIANO_IS_NULL
      || code == MEDIANO_IS_NULL
      || code == MEDIANO_IS_ORTHER
      || code == JSON_IS_NULL
      || code == JSON_PARSE_ERROE
      || code == BIND_ERROE
      || code == SCAN_PAY_CALL_FAIL
      || code == NO_NETWORK
      || code == NETWORK_ERROR
      || code == PAY_RESULT_JSON_PARSE_FAIL
      || code == AMOUNT_IS_NULL;

  bool get isUnknown => code == REVOKE_PARSE_ERROE
      || code == REVOKE_TIMEOUT
      || code == QUERY_UNKNOWN;
}

class CardPayCode {
  static const String CARD_PAY_SUCCESS = "60020200"; //支付成功	支付成功
  //明确失败
  static const String PAY_INFO_IS_NULL =
      "60020001"; //银行卡支付信息为空	"调用SDK支付方法，传入的json信息为null，如果使用SDK提供的方法调用不会出现这种情况"	支付失败，请重试
  static const String JSON_PARSE_ERROE =
      "60020002"; //支付信息解析错误	"调用SDK支付方法传入的json结构不对，如果使用SDK提供的方法调用不会出现这种情况 "	支付失败，请重试
  static const String ORDER_FORMAT_ERROR =
      "60020003"; //订单号格式不正确	支付传入的orderid为空或者长度大于32	订单有误，请检查后重试
  static const String CARD_PAY_FAIL =
      "60020004"; //支付失败+系统具体错误信息	"原因1：支付后获取结果为失败，原因2：交易被冲正 ，建议提示用户重新支付"	使用系统返回的信息
  static const String APP_OCCUPY =
      "60020007"; //有应用正在占用操作硬件	由于POS底层的关系，操作硬件只能单一进程操作	交易有误，请重试
  static const String DOWNLOAD_KEY_FAIL =
      "60020008"; //下载密钥失败	"做支付之前需要先下载相关的密钥，下载密钥由于网络的原因有可能下载失败，如果失败再次发起支付即可"	交易参数下载失败，请重试
  static const String READ_CARD_ERROR =
      "60020009"; //搜卡失败，请重试！	pos机搜索卡片的时候出现的异常建议提示用户"搜卡失败，请重试"	读卡有误，请换个姿势
  static const String AMOUNT_IS_NULL =
      "60020010"; //银行卡支付金额信息为空	金额格式不正确	订单金额有误，请确认后重试
  static const String READ_TIME_OUT =
      "60020011"; //读卡超时，请继续发起支付	在pos机搜卡的时间（60s）内未发现银行卡	读卡有误，请换个姿势
  static const String CT_READ_CARD_FAIL =
      "60020012"; //读卡失败，请保证银行卡或手机和POS机接触正常！	卡片和pos机接触不正常导致	读卡有误，请换个姿势
  static const String CANCEL_PASSWORD =
      "60020013"; //用户取消了密码键盘	"用户在输入密码键盘的地方关闭了密码键盘'建议参考收银服务回到主界面'"	用户拒绝输入密码，交易取消
  static const String PASSWORD_ERROR =
      "60020014"; //密码键盘超时或出错,请重新调起刷卡	在密码键盘显示的时间内没有输入密码确认,建议重新发起搜卡	密码有误，请重试
  static const String CT_IS_IC =
      "60020015"; //当前卡片是IC卡，请插卡支付	使用ic卡进行的刷卡操作，建议提示用户后重新发起搜卡	IC卡不许降级交易，请插卡交易。
  static const String CT_ERROR =
      "60020016"; //刷卡姿势不对或刷的不是正确的磁条卡 建议提示用户重新发起搜卡		读卡有误，请重试
  static const String IC_READ_CARD_FAIL =
      "60020017"; //IC卡读卡失败，请重新插卡	IC卡支付的时候POS显示的错误，建议提示用户并重新发起搜卡	读卡有误，请换个姿势
  static const String UNKNOWN_POS_TYPE =
      "60020018"; //未知的pos类型	支付插件安装在了不支持的pos机里面（一般不会出现）	蓝牙连接失败重新连接
  static const String NO_NETWORK =
      "60020030"; //没有网络，请检查网络设置	pos没有网络	无网络，请连接网络后再试
  static const String BIND_ERROE =
      "60020031"; //绑定失败，请检查是否添加了权限	绑定支付插件的时候绑定失败提示原因：清单文件没有添加权限或POS机中没有安装支付插件	权限不足，请校验后再试
  static const String CARD_PAY_CALL_FAIL =
      "60020032"; //调用银行卡支付方法失败	调用aidl方法出错	支付失败，请重试
  static const String CONNECT_ERROR =
      "60190204"; //蓝牙连接失败	（该返回码只有在P500S机型上会显示）需要重新连接蓝牙
  static const String PAY_RESULT_JSON_PARSE_FAIL =
      "60020043"; //支付返回的json数据解析对象时报错	支付插件返回给SDK的json去解析成对象的时候报错，这种情况基本上不会出现	请确认订单状态
  // 未明
  static const String CORRECT_PARSE_FAIL =
      "60020206"; //冲正解析数据失败，交易结果未知，应该调用查询接口//收到后台冲正结果但是解析的时候出现异常//请确认订单状态
  static const String PAY_TIMEOUT =
      "60020207"; //支付超时，交易结果未知，应该调用查询接口//"支付过程中SocketTimeoutException或UnknownHostException"//请确认订单状态
  static const String CORRECT_FAIL =
      "60020205"; //冲正失败，交易结果未知，应该调用查询接口//支付超时调用冲正，冲正超时返回这个//请确认订单状态
  // 刷卡状态流转中
  static const String START_READ_CARD =
      "60020107"; //开始读卡，可以提示用户刷银行卡了//提示收银员开始刷卡//交易请刷卡
  static const String DOWNLOAD_KEY_SUCCESS =
      "60020101"; //密钥下载成功//密钥下载成功//交易参数下载成功
  static const String PASSWORD_KEYBOARD_OPEN =
      "60020103"; //打开了密码键盘//打开了密码键盘//请输入密码
  static const String PASSWORD_KEYBOARD_CLOSE =
      "60020104"; //正常关闭了密码键盘//正常关闭了密码键盘，也就是用户点击了确认键//
  static const String SEND_PAY_REQUEST = "60020105"; //发起支付请求//发起支付请求//支付中

  CardPayCode(this.code);

  final String code;

  bool get isSuccess => code == CARD_PAY_SUCCESS;

  bool get isFailed => code == PAY_INFO_IS_NULL
      || code == JSON_PARSE_ERROE
      || code == ORDER_FORMAT_ERROR
      || code == CARD_PAY_FAIL
      || code == APP_OCCUPY
      || code == DOWNLOAD_KEY_FAIL
      || code == READ_CARD_ERROR
      || code == AMOUNT_IS_NULL
      || code == READ_TIME_OUT
      || code == CT_READ_CARD_FAIL
      || code == CANCEL_PASSWORD
      || code == PASSWORD_ERROR
      || code == CT_IS_IC
      || code == CT_ERROR
      || code == IC_READ_CARD_FAIL
      || code == UNKNOWN_POS_TYPE
      || code == NO_NETWORK
      || code == BIND_ERROE
      || code == CARD_PAY_CALL_FAIL
      || code == CONNECT_ERROR
      || code == PAY_RESULT_JSON_PARSE_FAIL;

  bool get isUnknown => code == CORRECT_PARSE_FAIL
      || code == PAY_TIMEOUT
      || code == CORRECT_FAIL;

  bool get isInProcess => code == START_READ_CARD
      || code == DOWNLOAD_KEY_SUCCESS
      || code == PASSWORD_KEYBOARD_OPEN
      || code == PASSWORD_KEYBOARD_CLOSE
      || code == SEND_PAY_REQUEST;
}
