import 'package:umfpaysdk/pay_sdk_result.dart';

/// desc:
/// author: hanpeidong
/// time: 2019/8/29
class SdkResult {
  int sdkCode;
  PaySdkResult paySdkResult;

  SdkResult.fromCash() {
    sdkCode = 1;
    paySdkResult = PaySdkResult.fromCash();
  }

  SdkResult.fromJson(Map<String, dynamic> jsonData) {
    sdkCode = jsonData['sdkCode'];
    if (jsonData['result'] != null) {
      paySdkResult = PaySdkResult.fromJson(jsonData['result']);
    }
  }

  bool get isSuccess => sdkCode == 1;

  bool get isFailed => sdkCode == 0;

  bool get isUnknown => sdkCode == 9;

  bool get isInProcess => sdkCode == 2;

  bool get isError => sdkCode == 4;

  @override
  String toString() {
    StringBuffer sb = new StringBuffer('{');
    sb.write("\"sdkCode\":$sdkCode");
    sb.write("\"paySdkResult\":$paySdkResult");
    sb.write('}');
    return sb.toString();
  }
}